function SMS_GetRecipientCarrierList( )
{
    if ( typeof RECIPIENT_CARRIER_LIST == 'undefined' )
    {
        RECIPIENT_CARRIER_LIST = new Array( );
        RECIPIENT_CARRIER_LIST[RECIPIENT_CARRIER_LIST.length]   = [ 'Select Carrier', INVALID_CARRIER_ID ];
        RECIPIENT_CARRIER_LIST[RECIPIENT_CARRIER_LIST.length]   = [ 'Not Sure',       0 ];

        var n;
        for ( n = 0; n < CARRIER_SET.length; ++n )
        {
            RECIPIENT_CARRIER_LIST[RECIPIENT_CARRIER_LIST.length] = [ CARRIER_SET[n][0], CARRIER_SET[n][1] ];
        }
    }

    return RECIPIENT_CARRIER_LIST;
}

function SMS_GetSenderCarrierList( )
{
    if ( typeof SENDER_CARRIER_LIST == 'undefined' )
    {
        SENDER_CARRIER_LIST = new Array( );
        SENDER_CARRIER_LIST[SENDER_CARRIER_LIST.length]   = [ 'Select Carrier', INVALID_CARRIER_ID ];

        var n;
        for ( n = 0; n < CARRIER_SET.length; ++n )
        {
            SENDER_CARRIER_LIST[SENDER_CARRIER_LIST.length] = [ CARRIER_SET[n][0], CARRIER_SET[n][1] ];
        }

        SENDER_CARRIER_LIST[SENDER_CARRIER_LIST.length] = [ 'International', INTERNATIONAL_CARRIER_ID ];
    }

    return SENDER_CARRIER_LIST;
}

function SMS_FindCarrierId( carrierName )
{
    if ( typeof LEGACY_CARRIER_SET == 'undefined' )
    {
        LEGACY_CARRIER_SET = new Array( );
        LEGACY_CARRIER_SET[ "---none---" ]          = INVALID_CARRIER_ID;
        LEGACY_CARRIER_SET[ "unknown" ]             = OTHER_CARRIER_ID;
        LEGACY_CARRIER_SET[ "cingular_only" ]       =  4;
        LEGACY_CARRIER_SET[ "cingular" ]            =  4;
        LEGACY_CARRIER_SET[ "sprint" ]              = 11;
        LEGACY_CARRIER_SET[ "verizon" ]             = 12;
        LEGACY_CARRIER_SET[ "alltel" ]              =  1;
        LEGACY_CARRIER_SET[ "cellular_south" ]      = 58;
        LEGACY_CARRIER_SET[ "at_t" ]                =  2;
        LEGACY_CARRIER_SET[ "cricket" ]             = 20;
        LEGACY_CARRIER_SET[ "dobson" ]              = 59;
        LEGACY_CARRIER_SET[ "metropcs" ]            = 23;
        LEGACY_CARRIER_SET[ "midwest_wireless" ]    = 31;
        LEGACY_CARRIER_SET[ "nextel" ]              =  7;
        LEGACY_CARRIER_SET[ "ntelos" ]              = 36;
        LEGACY_CARRIER_SET[ "suncom" ]              = 35;
        LEGACY_CARRIER_SET[ "tmobile" ]             = 14;
        LEGACY_CARRIER_SET[ "unicel" ]              = 38;
        LEGACY_CARRIER_SET[ "us_cellular" ]         = 15;
        LEGACY_CARRIER_SET[ "ca_aliant" ]           = 61;
        LEGACY_CARRIER_SET[ "ca_bell" ]             = 62;
        LEGACY_CARRIER_SET[ "ca_fido" ]             = 63;
        LEGACY_CARRIER_SET[ "ca_mts" ]              = 64;
        LEGACY_CARRIER_SET[ "ca_rogers" ]           = 65;
        LEGACY_CARRIER_SET[ "ca_sasktel" ]          = 66;
        LEGACY_CARRIER_SET[ "ca_telus" ]            = 67;
        LEGACY_CARRIER_SET[ "ca_virgin" ]           = 68;

        /**********************************************************
            The following legacy carriers are not supported and thus there
            is no mapping in the legacy set:
                ar_telecom_personal
                hr_vip
                fr_orange
                de_o2
                de_tmobile
                za_vodacom
                ua_kyivstar
                ua_umc
                acs_alaska
                alltell
                alltelpcs
                arch_wireless
                boost
                metrocall_pager
                qwest
                verizon_pager
                virgin
        **********************************************************/
    }

    // all the legacy names are in lower case
    carrierName = carrierName.toLowerCase( );

    // Widget v1.0 and v1.1 saved the 'text' of the carrier popup to prefs instead
    // of the value.  v1.2 and up uses the popup value, so this performs the
    // conversion if necessary.
    if ( carrierName == "t-mobile" )
    {
        carrierName = "tmobile";
    }

    var carrierId = LEGACY_CARRIER_SET[ carrierName ];

    if ( ! carrierId )
    {
        return INVALID_CARRIER_ID;
    }

    return carrierId;
}

function SMS_PopulateCarrierNames( element, carrierList )
{
    var i = 0;
    for ( ; i < carrierList.length; ++i )
    {
        element.options[ element.options.length ] = new Option( carrierList[ i ][ 0 ], carrierList[ i ][ 1 ] );
    }

    element.options[ 0 ].selected = true;
}